# Used third party content

## JSLinux

* Files: `static/lib/jslinux/*`
* URL: https://bellard.org/jslinux/
* Author: Fabrice Bellard
* License: [MIT License](https://opensource.org/licenses/MIT)

There is a downloadable JSLinux demo ZIP at https://bellard.org/tinyemu/. We started off with the ZIP file, reorganized the file structure and replaced some files with update versions from the website. Furthermore, we made several changes to those files, creating derivative files.

### Derivatives

* The file `static/index.html` contains parts of the original `index.html` available at https://bellard.org/jslinux
* `static/lib/jslinux/css/style.css`
  * Generally rewritten and shortened (to fit in with our design)
  * Modified paths to scrollbar images
  * Included missing `;`
* `static/lib/jslinux/img/`
  * `bg-scrollbar-thumb-y.png`: Colors changed so that it fits in with our design
  * We deleted the other image files as they weren't needed anymore
* `static/lib/jslinux/js/jslinux.js`
  * Modified path to VM (call of `loadScript` function)
  * Modified paths to distro images (and re-introduced a default path that was lost during update)
  * Added `get_hardcoded_params()` function to replace `get_params()`
* `static/lib/jslinux/distros/busybox/root-riscv64.cfg`
  * Modified path to hard drive file
* `static/lib/jslinux/distros/busybox/root-x86.cfg`
  * Modified path to hard drive file

## Fira Fonts

* Files: `static/lib/fira/*`
* URL: https://github.com/mozilla/Fira
* Author: The Mozilla Foundation and Telefonica S.A.
* License: [SIL Open Font License](https://github.com/mozilla/Fira/blob/master/LICENSE)

## Bootstrap Icons

* Files: `static/lib/bbootstrap-icons-1.11.3/*`
* URL: https://github.com/twbs/icons/releases/tag/v1.11.3
* Author: The Bootstrap Authors
* License: [MIT License](https://github.com/twbs/icons/blob/v1.11.3/LICENSE)

## Bee icon

* File: `img/bee-4789032.svg`
* URL: https://pixabay.com/vectors/bee-honey-bees-insect-nature-4789032/
* Author: [Doofus1977](https://pixabay.com/users/doofus1977-12591272/)
* License: [Pixabay License](https://pixabay.com/service/license/)

### Derivatives

We created some derivatives of this file:

* `img/bee.svg`: Edited SVG (colors changed, resized page, ...)
  * `img/bee.png`: File exported as PNG

## Centering image in README

We adapted the solution to center an image in README from the following Stack Overflow answer:

* Title of the question: How do you center text in Gitlab markdown?
* URL: https://stackoverflow.com/a/53273661/
* Author: [Simon Hyll](https://stackoverflow.com/users/5614602/simon-hyll)
* License: [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/)

## jQuery

jQuery is only used to embed the Zammad live chat. If you don't want to use Zammad live chat, you can remove jQuery entirely.

* Files: `static/lib/jquery/*`
* URL: https://jquery.com/download/
* Author: OpenJS Foundation and other contributors
* License: [MIT License](https://jquery.org/license/)

## CSS triangle

* Rule `aside .tooltip::after` in file of `static/css/test.css`
* Abstract idea of how to create a triangle and position it inspired by the following posts:
  * https://www.w3schools.com/css/css_tooltip.asp
  * https://stackoverflow.com/questions/18208839/pure-html-css-to-create-triangle-pointer-under-button
  * https://www.coding-dude.com/wp/css/create-a-triangle/


## Loader Animation

* Several rules in the file `static/css/yalikejazz.css` are adapted forms of a CSS loader from the CSS Loaders & Spinners repository
* URL: https://github.com/vineethtrv/css-loader
* Author: Vineeth.TR
* License: [MIT License](https://github.com/vineethtrv/css-loader/blob/f51b9ae2cad53582f009240f04fd830142799328/LICENSE)
