# YALIKEJAZZ

<!-- @@@ Solution adapted from Stack Overflow answer, see LICENSE-3RD-PARTY.md for detail @@@ -->
<div align="center">
<img src="img/bee.svg" width="200px" alt="YALIKEJAZZ logo" />
</div>
<!-- @@@ End adapted solution @@@ -->

Maintainer: Gruppe Technik <technik@cl.uni-heidelberg.de>

YALIKEJAZZ (“**Y**et **A**nother **L**inux **I**nterface **K**indly **E**valuating, **J**udging and **A**ssisting **Z**ealous **Z**oomers”) is a browser-based web application (a “fat client”) in which students can practice their Linux skills using simple, hands-on exercises. It replaces the old pool test.

[[_TOC_]]

## :runner: Run the application

Simply use any kind of static web server to serve the contents of the `static` directory. During development, you could e.g. use Python's `http.server` module:

```bash
cd static/
python -m http.server --bind 127.0.0.1
```

## :tools: Deploy to production

Set up the domain `yalikejazz.cl.uni-heidelberg.de` pointing to the server you want to deploy YALIKEJAZZ to and configure a web server of your choice that is able to serve static web content. For the rest of this section we will use an Apache web server.

### Virtual host configuration

This is not a step-by-step guide, only a documentation of results. When doing this step by step, you might want to create your configuration only for HTTP first, then have Certbot automatically issue you a Let's Encrypt certificate and create an HTTPS configuration, which you can more or less just leave as is.

You will probably need two virtual hosts:

<details>
<summary><code>/etc/apache2/sites-enabled/yalikejazz.cl.uni-heidelberg.de.conf</code></summary>

```apache
<VirtualHost yalikejazz.cl.uni-heidelberg.de:80>
        ServerName yalikejazz.cl.uni-heidelberg.de
        RedirectPermanent / https://yalikejazz.cl.uni-heidelberg.de/
</VirtualHost>
```

This virtual host simply redirects any HTTP request to the HTTPS endpoint.

</details>


<details>
<summary><code>/etc/apache2/sites-enabled/yalikejazz.cl.uni-heidelberg.de-le-ssl.conf</code></summary>

```apache
<IfModule mod_ssl.c>
<VirtualHost yalikejazz.cl.uni-heidelberg.de:443>
        ServerName yalikejazz.cl.uni-heidelberg.de
        DocumentRoot /var/www/vhosts/yalikejazz

        AddType application/javascript .mjs

        SSLCertificateFile /etc/letsencrypt/live/yalikejazz.cl.uni-heidelberg.de/fullchain.pem
        SSLCertificateKeyFile /etc/letsencrypt/live/yalikejazz.cl.uni-heidelberg.de/privkey.pem
        Include /etc/letsencrypt/options-ssl-apache.conf

        Header always set Strict-Transport-Security "max-age=31536000; includeSubDomains"
        Header always set X-Frame-Options "SAMEORIGIN"
        Header always set Referrer-Policy "no-referrer"
        Header always set X-Content-Type-Options "nosniff"
        Header always set Content-Security-Policy "default-src 'self' https://tickets.technik.cl.uni-heidelberg.de; style-src 'self' 'unsafe-inline' https://tickets.technik.cl.uni-heidelberg.de data:; connect-src 'self' wss://tickets.technik.cl.uni-heidelberg.de; img-src 'self' http://tickets.technik.cl.uni-heidelberg.de https://tickets.technik.cl.uni-heidelberg.de; script-src 'self' https://tickets.technik.cl.uni-heidelberg.de 'wasm-unsafe-eval'" env=!safari

        BrowserMatch Safari safari
        Header set Content-Security-Policy "default-src 'self' https://tickets.technik.cl.uni-heidelberg.de; style-src 'self' 'unsafe-inline' https://tickets.technik.cl.uni-heidelberg.de data:; connect-src 'self' wss://tickets.technik.cl.uni-heidelberg.de; img-src 'self' http://tickets.technik.cl.uni-heidelberg.de https://tickets.technik.cl.uni-heidelberg.de; script-src 'self' https://tickets.technik.cl.uni-heidelberg.de 'unsafe-eval'" env=safari

        RedirectMatch ^/verify https://www.youtube.com/watch?v=dQw4w9WgXcQ
</VirtualHost>
</IfModule>
```

This virtual host contains the actual website configuration and the SSL configuration.

</details>

### Copying files

You now need to copy the contents of the `static/` directory into `/var/www/vhosts/yalikejazz` (or whichever `DocumentRoot` you specified). That's it :)

On `reed`, you can execute the following script to do the tedious copying work for you ;)

```bash
/root/technik_git/deploy/yalikejazz.sh
```

This will copy the files from `/root/technik_git/yalikejazz/`, where the cloned repository resides.

## :name_badge: Where does the name come from?

“Ya Like Jazz?“ is a [quote from the 2007 film Bee Movie][quote] that has gained some popularity on the internet.

## :scales: Sources and license

This project is licensed under the [MIT license](https://opensource.org/licenses/MIT), for details see the file [`LICENSE`](LICENSE).

This project uses content provided by third parties. Please see the [`LICENSE-3RD-PARTY.md`](LICENSE-3RD-PARTY.md) file to find out which files are content provided by third parties and under which license they are being used.

[quote]: https://youtu.be/L46syxgju18?t=40
