/**
 * @param {Date} now Now
 * @returns The first of the current month, as date object
 */
function getFirstOfMonth(now) {
    return new Date(now.getFullYear(), now.getMonth(), 1)
}

function addDays(date, daysToAdd) {
    return new Date(date.getFullYear(), date.getMonth(), date.getDate() + daysToAdd)
}

const now = new Date()

// Yes, the date uses zero-based indexing for months...
const APRIL = 3
const OCTOBER = 9

const SATURDAY = 6 // Saturday is the 6th day of the week, with Sunday being the 0th

if(now.getMonth() === APRIL || now.getMonth() === OCTOBER) {
    // We have a new semester now, so we want to hide the pool test until the Saturday before the lectures start.
    // Lectures start more or less in the middle of the month, so the following logic works out what date this saturday is.
    const first = getFirstOfMonth(now)
    const firstWeekday = first.getDay()
    const unlockDate = firstWeekday === SATURDAY ? addDays(first, 14) : addDays(first, 13 - firstWeekday)

    if(now.getDate() < unlockDate.getDate()) {
        document.querySelector("#pooltest-start-btn").style.display = "none"
    }
}
