/**
 * Show (or hide) a tooltip.
 * 
 * @param {string} id The id of the tooltip
 * @param {boolean} shown If the tooltip should be shown or hidden
 */
 export function setTooltipShown(id, shown) {
    const TOOLTIP_SHOWN = "tooltip-shown"
    const tooltip = document.querySelector(`#${id}`)

    if (shown) {
        tooltip.style.display = "block"
        setTimeout(()=>tooltip.classList.add(TOOLTIP_SHOWN), 10)
    } else {
        tooltip.classList.remove(TOOLTIP_SHOWN)
        setTimeout(()=>tooltip.style.display = "none", 500)
    }
}
